Index: lib/class.tx_linkvalidator_checkbase.php
===================================================================
--- lib/class.tx_linkvalidator_checkbase.php	(revision 39777)
+++ lib/class.tx_linkvalidator_checkbase.php	(working copy)
@@ -29,7 +29,7 @@
  */
 abstract class tx_linkvalidator_checkbase {
 
-	abstract function checkLink($url, $reference);
+	abstract function checkLink($url, $softRefEntry, $reference);
 	
     /**
      * Base type fetching method, based on the type that softRefParserObj returns.
Index: lib/class.tx_linkvalidator_checkexternallinks.php
===================================================================
--- lib/class.tx_linkvalidator_checkexternallinks.php	(revision 39777)
+++ lib/class.tx_linkvalidator_checkexternallinks.php	(working copy)
@@ -35,10 +35,11 @@
 	 * Checks a given URL + /path/filename.ext for validity
 	 *
 	 * @param	string		$url: url to check
+	 * @param	 array       $softRefEntry: the softref entry which builds the context of that url
 	 * @param	object		$reference:  parent instance of tx_linkvalidator_processing
 	 * @return	string		validation error message or succes code
 	 */
-	function checkLink($url, $reference) {
+	function checkLink($url, $softRefEntry, $reference) {
 		if($this->url_reports[$url]) {
 			return $this->url_reports[$url];
 		}
Index: lib/class.tx_linkvalidator_checkfilelinks.php
===================================================================
--- lib/class.tx_linkvalidator_checkfilelinks.php	(revision 39777)
+++ lib/class.tx_linkvalidator_checkfilelinks.php	(working copy)
@@ -33,10 +33,11 @@
      * Checks a given URL + /path/filename.ext for validity
      *
      * @param   string      $url: url to check
+     * @param	 array       $softRefEntry: the softref entry which builds the context of that url
      * @param   object      $reference:  parent instance of tx_linkvalidator_processing
      * @return  string      validation error message or succes code
      */
-	function checkLink($url, $reference) {
+	function checkLink($url, $softRefEntry, $reference) {
 		if (!@file_exists(PATH_site.rawurldecode($url))) {
 			return $GLOBALS['LANG']->getLL('list.report.filenotexisting');
 		}
Index: lib/class.tx_linkvalidator_checkinternallinks.php
===================================================================
--- lib/class.tx_linkvalidator_checkinternallinks.php	(revision 39777)
+++ lib/class.tx_linkvalidator_checkinternallinks.php	(working copy)
@@ -33,10 +33,11 @@
      * Checks a given URL + /path/filename.ext for validity
      *
      * @param   string      $url: url to check
+     * @param	 array       $softRefEntry: the softref entry which builds the context of that url
      * @param   object      $reference:  parent instance of tx_linkvalidator_processing
      * @return  string      validation error message or succes code
      */
-	function checkLink($url, $reference) {
+	function checkLink($url, $softRefEntry, $reference) {
 		$rows = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
 			'uid, deleted, title',
 			'pages',
Index: lib/class.tx_linkvalidator_checklinkhandlerlinks.php
===================================================================
--- lib/class.tx_linkvalidator_checklinkhandlerlinks.php	(revision 39777)
+++ lib/class.tx_linkvalidator_checklinkhandlerlinks.php	(working copy)
@@ -41,10 +41,11 @@
      * Checks a given URL + /path/filename.ext for validity
      *
      * @param   string      $url: url to check
+     * @param	 array       $softRefEntry: the softref entry which builds the context of that url
      * @param   object      $reference:  parent instance of tx_linkvalidator_processing
      * @return  string      validation error message or succes code
      */
-	function checkLink($url, $reference) {
+	function checkLink($url, $softRefEntry, $reference) {
 		$parts = explode(":", $url);
 		if(count($parts) == 3) {
 			$tablename = htmlspecialchars($parts[1]);
Index: lib/class.tx_linkvalidator_processing.php
===================================================================
--- lib/class.tx_linkvalidator_processing.php	(revision 39777)
+++ lib/class.tx_linkvalidator_processing.php	(working copy)
@@ -175,7 +175,7 @@
 					$record['field'] = $entryValue['field'];
 					$url = $entryValue['substr']['tokenValue'];
 					$this->linkCounts[$table]++;
-					$checkURL = $hookObj->checkLink($url, $this);
+					$checkURL = $hookObj->checkLink($url,  $entryValue, $this);
 					// broken link found!
 					if ($checkURL != 1) {
 						$this->brokenLinkCounts[$table]++;