Index: typo3/js/extjs/viewportConfiguration.js
===================================================================
--- typo3/js/extjs/viewportConfiguration.js	(date 1301422673021)
+++ typo3/js/extjs/viewportConfiguration.js	(date 1301422634000)
@@ -90,7 +90,8 @@
 							border: false,
 							hidden: true,
 							xtype: 'iframePanel',
-							name: 'navigation'
+							name: 'navigation',
+							doMask: top.TYPO3.configuration.showLoadingMask
 						}
 					]
 				},
@@ -106,6 +107,7 @@
 							hidden: true,
 							floatable: true,
 							xtime: 'iframePanel',
+							doMask: top.TYPO3.configuration.showLoadingMask,
 							width: 5
 						},
 						{
@@ -114,6 +116,7 @@
 							anchor: '100% 100%',
 							border: false,
 							xtype: 'iframePanel',
+							doMask: top.TYPO3.configuration.showLoadingMask,
 							name: 'content'
 						}
 					]
Index: typo3/sysext/setup/mod/locallang.xml
===================================================================
--- typo3/sysext/setup/mod/locallang.xml	(date 1301422673021)
+++ typo3/sysext/setup/mod/locallang.xml	(date 1301422634000)
@@ -120,6 +120,7 @@
 			<label index="tempDataClearedLog">Temporary data cleared</label>
 			<label index="settingsAreReset">The user settings have been reset to default values and temporary data has been cleared.</label>
 			<label index="debugInWindow">Display debug messages in a new browser window</label>
+			<label index="disableLoadingMask">Disables the loading mask in content frame</label>
 		</languageKey>
 	</data>
 </T3locallang>
Index: typo3/sysext/setup/ext_tables.php
===================================================================
--- typo3/sysext/setup/ext_tables.php	(date 1301422673021)
+++ typo3/sysext/setup/ext_tables.php	(date 1301422634000)
@@ -133,10 +133,15 @@
 			'access' => 'admin',
 			'csh' => 'enableInstallTool'
 		),
+		'disableLoadingMask' => array(
+			'type' => 'check',
+			'label' => 'LLL:EXT:setup/mod/locallang.xml:disableLoadingMask',
+			'csh' => 'disableLoadingMask'
-	),
+		),
+	),
 	'showitem' => '--div--;LLL:EXT:setup/mod/locallang.xml:personal_data,realName,email,emailMeAtLogin,password,password2,lang,
 			--div--;LLL:EXT:setup/mod/locallang.xml:opening,startModule,thumbnailsByDefault,titleLen,
-			--div--;LLL:EXT:setup/mod/locallang.xml:editFunctionsTab,edit_RTE,edit_wideDocument,edit_docModuleUpload,enableFlashUploader,resizeTextareas,resizeTextareas_MaxHeight,resizeTextareas_Flexible,disableCMlayers,copyLevels,recursiveDelete,
+			--div--;LLL:EXT:setup/mod/locallang.xml:editFunctionsTab,edit_RTE,edit_wideDocument,edit_docModuleUpload,enableFlashUploader,resizeTextareas,resizeTextareas_MaxHeight,resizeTextareas_Flexible,disableCMlayers,copyLevels,recursiveDelete,disableLoadingMask,
 			--div--;LLL:EXT:setup/mod/locallang.xml:adminFunctions,simulate,debugInWindow,installToolEnableButton'
 
 );
Index: typo3/sysext/setup/locallang_csh_mod.xml
===================================================================
--- typo3/sysext/setup/locallang_csh_mod.xml	(date 1301422673021)
+++ typo3/sysext/setup/locallang_csh_mod.xml	(date 1301422634000)
@@ -110,6 +110,7 @@
 			<label index="simuser.description">This option allows &quot;admin&quot;-users to change settings for another backend user in the system.</label>
 			<label index="option_enableInstallTool.alttitle">Admin control for re-enabling Install Tool access</label>
 			<label index="option_enableInstallTool.description">By clicking this button, a file typo3conf/ENABLE_INSTALL_TOOL is created (or removed if it already exists). It unlocks the access to the Install Tool (password is still needed!) and will be removed automatically after 1 hour.</label>
+			<label index="option_disableLoadingMask.description">This option removes the loading mask of the content frame, if set. After changing this option, the backend has to be reloaded to apply the setting.</label>
 		</languageKey>
 	</data>
 </T3locallang>
\ No newline at end of file
Index: typo3/backend.php
===================================================================
--- typo3/backend.php	(date 1301422673021)
+++ typo3/backend.php	(date 1301422634000)
@@ -566,6 +566,7 @@
 				'height' => 400
 			),
 			'firstWebmountPid' => intval($GLOBALS['WEBMOUNTS'][0]),
+			'showLoadingMask' =>  $GLOBALS['BE_USER']->uc['disableLoadingMask'] ? 0 : 1 ,
 		);
 		if ($GLOBALS['LANG']->charSet !== 'utf-8') {
 			$t3Configuration['username'] = $GLOBALS['LANG']->csConvObj->conv($t3Configuration['username'], $GLOBALS['LANG']->charSet, 'utf-8');